=begin
#ChannelShipper & Royal Mail Public API

#Import your orders, retrieve your orders and generate labels.

OpenAPI spec version: 1.0.0

Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 3.0.34
=end

require 'date'

module RoyalMail
  class GetManifestResponse
    # * <b>InProgress</b>: Manifest operation is currently in progress * <b>Completed</b>: Manifest operation has been completed * <b>Failed</b>: Manifest operation has failed 
    attr_accessor :manifest_status

    # * <b>InProgress</b>: Manifest documentation generation is currently in progress * <b>Completed</b>: Manifest documentation generation has been completed 
    attr_accessor :document_status

    attr_accessor :error_reference

    attr_accessor :orders

    # pdf file encoded as base64 format string
    attr_accessor :pdf

    class EnumAttributeValidator
      attr_reader :datatype
      attr_reader :allowable_values

      def initialize(datatype, allowable_values)
        @allowable_values = allowable_values.map do |value|
          case datatype.to_s
          when /Integer/i
            value.to_i
          when /Float/i
            value.to_f
          else
            value
          end
        end
      end

      def valid?(value)
        !value || allowable_values.include?(value)
      end
    end

    # Attribute mapping from ruby-style variable name to JSON key.
    def self.attribute_map
      {
        :'manifest_status' => :'manifestStatus',
        :'document_status' => :'documentStatus',
        :'error_reference' => :'errorReference',
        :'orders' => :'orders',
        :'pdf' => :'pdf'
      }
    end

    # Attribute type mapping.
    def self.openapi_types
      {
        :'manifest_status' => :'Object',
        :'document_status' => :'Object',
        :'error_reference' => :'Object',
        :'orders' => :'Object',
        :'pdf' => :'Object'
      }
    end

    # List of attributes with nullable: true
    def self.openapi_nullable
      Set.new([
      ])
    end
  
    # Initializes the object
    # @param [Hash] attributes Model attributes in the form of hash
    def initialize(attributes = {})
      if (!attributes.is_a?(Hash))
        fail ArgumentError, "The input argument (attributes) must be a hash in `RoyalMail::GetManifestResponse` initialize method"
      end

      # check to see if the attribute exists and convert string to symbol for hash key
      attributes = attributes.each_with_object({}) { |(k, v), h|
        if (!self.class.attribute_map.key?(k.to_sym))
          fail ArgumentError, "`#{k}` is not a valid attribute in `RoyalMail::GetManifestResponse`. Please check the name to make sure it's valid. List of attributes: " + self.class.attribute_map.keys.inspect
        end
        h[k.to_sym] = v
      }

      if attributes.key?(:'manifest_status')
        self.manifest_status = attributes[:'manifest_status']
      end

      if attributes.key?(:'document_status')
        self.document_status = attributes[:'document_status']
      end

      if attributes.key?(:'error_reference')
        self.error_reference = attributes[:'error_reference']
      end

      if attributes.key?(:'orders')
        if (value = attributes[:'orders']).is_a?(Array)
          self.orders = value
        end
      end

      if attributes.key?(:'pdf')
        self.pdf = attributes[:'pdf']
      end
    end

    # Show invalid properties with the reasons. Usually used together with valid?
    # @return Array for valid properties with the reasons
    def list_invalid_properties
      invalid_properties = Array.new
      invalid_properties
    end

    # Check to see if the all the properties in the model are valid
    # @return true if the model is valid
    def valid?
      manifest_status_validator = EnumAttributeValidator.new('Object', ['InProgress', 'Completed', 'Failed'])
      return false unless manifest_status_validator.valid?(@manifest_status)
      document_status_validator = EnumAttributeValidator.new('Object', ['InProgress', 'Completed'])
      return false unless document_status_validator.valid?(@document_status)
      true
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] manifest_status Object to be assigned
    def manifest_status=(manifest_status)
      validator = EnumAttributeValidator.new('Object', ['InProgress', 'Completed', 'Failed'])
      unless validator.valid?(manifest_status)
        fail ArgumentError, "invalid value for \"manifest_status\", must be one of #{validator.allowable_values}."
      end
      @manifest_status = manifest_status
    end

    # Custom attribute writer method checking allowed values (enum).
    # @param [Object] document_status Object to be assigned
    def document_status=(document_status)
      validator = EnumAttributeValidator.new('Object', ['InProgress', 'Completed'])
      unless validator.valid?(document_status)
        fail ArgumentError, "invalid value for \"document_status\", must be one of #{validator.allowable_values}."
      end
      @document_status = document_status
    end

    # Checks equality by comparing each attribute.
    # @param [Object] Object to be compared
    def ==(o)
      return true if self.equal?(o)
      self.class == o.class &&
          manifest_status == o.manifest_status &&
          document_status == o.document_status &&
          error_reference == o.error_reference &&
          orders == o.orders &&
          pdf == o.pdf
    end

    # @see the `==` method
    # @param [Object] Object to be compared
    def eql?(o)
      self == o
    end

    # Calculates hash code according to all attributes.
    # @return [Integer] Hash code
    def hash
      [manifest_status, document_status, error_reference, orders, pdf].hash
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def self.build_from_hash(attributes)
      new.build_from_hash(attributes)
    end

    # Builds the object from hash
    # @param [Hash] attributes Model attributes in the form of hash
    # @return [Object] Returns the model itself
    def build_from_hash(attributes)
      return nil unless attributes.is_a?(Hash)
      self.class.openapi_types.each_pair do |key, type|
        if type =~ /\AArray<(.*)>/i
          # check to ensure the input is an array given that the attribute
          # is documented as an array but the input is not
          if attributes[self.class.attribute_map[key]].is_a?(Array)
            self.send("#{key}=", attributes[self.class.attribute_map[key]].map { |v| _deserialize($1, v) })
          end
        elsif !attributes[self.class.attribute_map[key]].nil?
          self.send("#{key}=", _deserialize(type, attributes[self.class.attribute_map[key]]))
        elsif attributes[self.class.attribute_map[key]].nil? && self.class.openapi_nullable.include?(key)
          self.send("#{key}=", nil)
        end
      end

      self
    end

    # Deserializes the data based on type
    # @param string type Data type
    # @param string value Value to be deserialized
    # @return [Object] Deserialized data
    def _deserialize(type, value)
      case type.to_sym
      when :DateTime
        DateTime.parse(value)
      when :Date
        Date.parse(value)
      when :String
        value.to_s
      when :Integer
        value.to_i
      when :Float
        value.to_f
      when :Boolean
        if value.to_s =~ /\A(true|t|yes|y|1)\z/i
          true
        else
          false
        end
      when :Object
        # generic object (usually a Hash), return directly
        value
      when /\AArray<(?<inner_type>.+)>\z/
        inner_type = Regexp.last_match[:inner_type]
        value.map { |v| _deserialize(inner_type, v) }
      when /\AHash<(?<k_type>.+?), (?<v_type>.+)>\z/
        k_type = Regexp.last_match[:k_type]
        v_type = Regexp.last_match[:v_type]
        {}.tap do |hash|
          value.each do |k, v|
            hash[_deserialize(k_type, k)] = _deserialize(v_type, v)
          end
        end
      else # model
        RoyalMail.const_get(type).build_from_hash(value)
      end
    end

    # Returns the string representation of the object
    # @return [String] String presentation of the object
    def to_s
      to_hash.to_s
    end

    # to_body is an alias to to_hash (backward compatibility)
    # @return [Hash] Returns the object in the form of hash
    def to_body
      to_hash
    end

    # Returns the object in the form of hash
    # @return [Hash] Returns the object in the form of hash
    def to_hash
      hash = {}
      self.class.attribute_map.each_pair do |attr, param|
        value = self.send(attr)
        if value.nil?
          is_nullable = self.class.openapi_nullable.include?(attr)
          next if !is_nullable || (is_nullable && !instance_variable_defined?(:"@#{attr}"))
        end

        hash[param] = _to_hash(value)
      end
      hash
    end

    # Outputs non-array value in the form of hash
    # For object, use to_hash. Otherwise, just return the value
    # @param [Object] value Any valid value
    # @return [Hash] Returns the value in the form of hash
    def _to_hash(value)
      if value.is_a?(Array)
        value.compact.map { |v| _to_hash(v) }
      elsif value.is_a?(Hash)
        {}.tap do |hash|
          value.each { |k, v| hash[k] = _to_hash(v) }
        end
      elsif value.respond_to? :to_hash
        value.to_hash
      else
        value
      end
    end  end
end
